#include "/lib/head.glsl"

attribute vec3 at_midBlock;
attribute vec4 at_tangent;
attribute vec4 mc_Entity;
attribute vec4 mc_midTexCoord;

uniform mat4 shadowModelViewInverse;

out vertexOut {
    flat int voxelMode;
    flat int blockID;
    flat int emissionID;

    vec2 UV;
    vec2 MidUV;

    vec3 Tint;
    vec3 LocalLocation;
    vec3 SceneLocation;
    vec3 CenteredSceneLocation;
    flat vec3 Normal;

    flat vec4 Tangent;
};

bool isEmissive(int blockID) {
    return (blockID == 1000 || blockID == 1001 || blockID == 1002 || blockID == 1020 || blockID == 1021 || blockID == 1022 || blockID == 10002);
}

#include "/lib/light/idTable.glsl"

void main() {
    UV              = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
    MidUV           = (gl_TextureMatrix[0] * mc_midTexCoord).xy;

    Tint            = gl_Color.rgb;

    vec4 position   = gl_Vertex;

    LocalLocation   = position.xyz;

        position    = gl_ModelViewMatrix * position;
        position    = shadowModelViewInverse * position;

    SceneLocation   = position.xyz;

    CenteredSceneLocation = position.xyz + (at_midBlock / 64.0) * 0.9;

    Normal          = gl_Normal;
    Tangent         = at_tangent;

    int mcEntity    = int(mc_Entity.x);

    voxelMode       = 1;
    if (mcEntity == 0
     || mcEntity == 1010
     || mcEntity == 10022
     || mcEntity == 10023
     || mcEntity == 10024
     || mcEntity == 10025
     || mcEntity == 1040
     || mcEntity == 1100
     ) voxelMode = 0;

    if (mcEntity == 1020
     || mcEntity == 1021) voxelMode = 2;

    blockID         = 0;
    if (mcEntity == 10001) blockID = 102;

    emissionID      = remapEmissionID(mcEntity);
}